// Generated by CoffeeScript 1.12.3

/*
convert data to CSV format for easy import into spreadsheets
 */

(function() {
  var i18n, sloc;

  sloc = require('../sloc');

  i18n = require('../i18n');

  module.exports = function(data, options) {
    var f, i, k, len, lineize, lines, ref, s;
    if (options == null) {
      options = {};
    }
    if (data == null) {
      return console.error("Error: missing data");
    }
    lines = i18n.en.Path + "," + (((function() {
      var i, len, ref, results;
      ref = sloc.keys;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        k = ref[i];
        results.push(i18n.en[k]);
      }
      return results;
    })()).join(',')) + "\n";
    lineize = function(t) {
      return ((function() {
        var i, len, ref, results;
        ref = sloc.keys;
        results = [];
        for (i = 0, len = ref.length; i < len; i++) {
          k = ref[i];
          results.push(t[k]);
        }
        return results;
      })()).join(',');
    };
    if (options.details) {
      ref = data.files;
      for (i = 0, len = ref.length; i < len; i++) {
        f = ref[i];
        if (f.stats != null) {
          lines += f.path + "," + (lineize(f.stats)) + "\n";
        }
      }
    } else if ((s = data.summary) != null) {
      lines += i18n.en.Total + ',' + lineize(s);
    }
    if (lines[lines.length - 1] === '\n') {
      lines = lines.slice(0, -1);
    }
    return lines;
  };

}).call(this);
